import json

from django import http
from django.shortcuts import render

# Create your views here.
from django.views import View
from django.db import connection, transaction
import datetime

from utils.cust_data import customer_data
from utils.examine_ood import examine_ood
from utils.invoice_dh import invoice_dh
from utils.usr_data import usr_data

class salesView(View):
    @transaction.atomic
    def get(self, request):
        context = {
            'a': 'get预付冲应付作业'
        }
        return http.JsonResponse(context)

    @transaction.atomic
    def post(self, request):
        # 1,获取参数
        ZL_NO = request.POST.get("ZL_NO")  # 单据号码    1         字符型
        LZ_DD = request.POST.get("LZ_DD")  # 单据日期    1         字符型
        INV_NO = request.POST.get("INV_NO")  # 发票号码    1       字符型
        # INV_DD = request.POST.get("INV_DD")   #发票日期     1      字符型               不需要
        ZHANG_ID = request.POST.get("ZHANG_ID")  # 立账方式   1    字符型  2开票 1直接立账
        # TAX_ID = request.POST.get("TAX_ID")   #扣税类别   1         字符型                    不需要
        AMT = request.POST.get("AMT")  # 开票金额        1          数字型
        CUS_NO = request.POST.get("CUS_NO")  # 开票客户编码    1    字符型
        CUS_NO_NAME = request.POST.get("CUS_NO_NAME")  # 开票客户名称     1       字符型
        UNI_NO_PAY = request.POST.get("UNI_NO_PAY")  # 纳税人识别码   1           字符型
        SAL_ADR = request.POST.get("SAL_ADR")  # 开票客户地址   1                 字符型
        SAL_TEL = request.POST.get("SAL_TEL")  # 开票客户电话   1                 字符型
        SAL_KH_BANK = request.POST.get("SAL_KH_BANK")  # 开户账号   1            字符型
        USR = request.POST.get("USR")  # 制单人编码   1                           字符型
        USR_NAME = request.POST.get("USR_NAME")  # 制单人姓名   1                字符型
        SAL_ID_CODE = request.POST.get("SAL_ID_CODE")  # 开户银行账号   1       字符型
        REM = request.POST.get("REM")  # 发票备注   1

        # 判断立账方式是否有效
        if int(ZHANG_ID) != 1 and int(ZHANG_ID) != 2:
            return http.HttpResponseForbidden('立账方式只能是1（开票）,2（不开票）')

        # 判断开票单号是否存在
        if int(ZHANG_ID) == 2:
            row_ZL_NO = examine_ood('MF_LZ1', 'LZ_NO', ZL_NO, 'LZ_ID', 'LP')
            print(row_ZL_NO)
            if row_ZL_NO > 0:
                return http.HttpResponseForbidden('开票单号已存在')

        # 判断客户资料是否存在，不存在则创建
        row_cus_no = customer_data(CUS_NO, CUS_NO_NAME, '2', datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'))

        # 判断用户是否存在，不存在则创建
        row_usr = usr_data(USR, USR_NAME, datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'))

        with connection.cursor() as cursor:
            #直接开发票
            if int(ZHANG_ID) == 2:
                pass
                # cursor.execute("""UPDATE TF_PSS SET AMT_FP=%s,AMTN_NET_FP=%s WHERE PS_NO=%s""",[AMT, AMT, 'PC' + ZL_NO[2::]])
                # 插入销货单表头
                cursor.execute("""INSERT INTO MF_PSS(PS_ID,PS_NO,PS_DD,CUS_NO,ZHANG_ID,USR,CHK_MAN,CLS_DATE,SYS_DATE,AMT,EXC_RTO,LZ_CLS_ID,CLSLZ,TAX_ID,YD_ID)
                VALUES('SA',%s,%s,%s,3,%s,%s,%s,%s,%s,1,'F','F',1,'T')""",
                [ 'SA' + ZL_NO[2::], datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'), CUS_NO,USR,USR,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),
                datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),AMT])
                #插入销货单表身
                cursor.execute("""INSERT INTO TF_PSS(PS_ID,PS_NO,PS_DD,WH,PRD_NO,PRD_NAME,QTY,UP,AMT,AMTN_NET,TAX_RTO,ITM,UNIT,CSTN_SAL,PRE_ITM)
                VALUES('SA',%s,%s,'0000','AQ001','服務費用',1,1,%s,%s,5,1,1,%s,1)""",['SA' + ZL_NO[2::], datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'), AMT,AMT,AMT])
                #插入发票
                cursor.execute("""INSERT INTO INV_NO (BIL_NO,INV_NO,BIL_ID,INV_ID,CUS_NO,TITLE_BUY,TITLE_PAY,AMT,TAX_ID1,TAX_ID2,INV_TT,INV_DD,UNI_NO_PAY,SAL_ADR,SAL_TEL,SAL_KH_BANK,SAL_ID_CODE,REM)
                VALUES(%s,%s,'LZ',21,%s,%s,%s,%s,1,1,1,%s,%s,%s,%s,%s,%s,%s)""",[ZL_NO, INV_NO, CUS_NO, CUS_NO_NAME, CUS_NO_NAME, AMT,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),
                UNI_NO_PAY, SAL_ADR, SAL_TEL, SAL_KH_BANK, SAL_ID_CODE, REM])
                #插入立账单
                cursor.execute("""INSERT INTO MF_ARP(ARP_ID,OPN_ID,ARP_NO,BIL_NO,CUS_NO,PAY_DD,INV_NO,AMT,AMTN,AMTN_NET,EXC_RTO,CLOSE_ID,BIL_ID,SYS_DATE,BIL_DD)VALUES
                (1,2,%s,%s,%s,%s,200001,110,110,110,1,'F','LZ',%s,%s)""",['AR' + ZL_NO[2::], ZL_NO, CUS_NO,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),
                INV_NO,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),datetime.datetime.strptime(LZ_DD, '%Y-%m-%d')])
                #插入开票单表头
                cursor.execute("""INSERT INTO MF_LZ(LZ_ID,LZ_NO,PAY_DD,LZ_DD,CUS_NO,INV_NO,EXC_RTO,USR,CHK_MAN,AMT,AMTN_NET,ARP_NO,CLS_DATE,TAX_ID,ZHANG_ID,SYS_DATE,VOH_CHK,TURN_ID,INV_BIL_ID,INV_BIL_NO,FLG_VOH)VALUES
                ('LZ',%s,%s,%s,%s,%s,1,%s,%s,%s,%s,%s,%s,'1',3,%s,1,1,'LZ',%s,'F')""",
                [ZL_NO,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),CUS_NO,INV_NO,USR,USR, AMT,AMT, 'AR' + ZL_NO[2::],datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),
                 datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'),ZL_NO])
                # 插入开票单表身
                cursor.execute("""INSERT INTO TF_LZ(LZ_ID,LZ_NO,ITM,CK_NO,AMT,AMTN_NET,PRD_NO,EST_ITM,PAY_DD,TAX_RTO,QTY,UP,BIL_ID,UNIT,PRD_NAME,CUS_NO,UP_ZG,PRE_ITM)VALUES
                ('LZ',%s,1,%s,%s,%s,'AQ001',1,%s,5,1,1,'SA',1,'服務費用',%s,1,1)""",[ZL_NO, 'SA' + ZL_NO[2::],AMT,AMT,datetime.datetime.strptime(LZ_DD, '%Y-%m-%d'), CUS_NO])
                # 修改销货单开票金额
                cursor.execute("""UPDATE TF_PSS SET AMT_FP=ISNULL(AMT_FP,0)+%s,AMTN_NET_FP=ISNULL(AMTN_NET_FP,0)+%s WHERE PS_NO=%s AND PS_ID='SA'""",
                               [AMT, AMT, 'SA' + ZL_NO[2::]])